# Usage
#
# tag(
#   'h3',
#   content: bind do |binding|
#     # set up the watch
#     -> {
#       binding.value = user.name
#     }.watch!
#   end
# )

module CSR
  module DOM
    class BoundProc
      attr_reader :proc

      def initialize(proc=nil, &block)
        @proc = proc || block
      end
    end

    class Binding

      attr_reader :value

      def initialize(value_proc, action_proc)
        @value_proc = value_proc
        @action_proc = action_proc
        @value = nil
        @value_proc.call(self)
      end

      # TODO: make equality checking optional?
      def value=(arg)
        unless @value == arg
          @value = arg
          @action_proc.call(arg)
        end
      end

    end
  end
end