require 'dom/globals'
require 'dom/util'
require 'dom/debug'

module CSR
  module DOM
    module Root
      include CSR::DOM::Globals
      include CSR::DOM::Util
      include CSR::DOM::Debug

      module_function

      # TODO: should this be here?
      def dom_root
        unless @dom_root
          if respond_to? :first_element # or container, Volt methods
            # debug 1, ->{[ __FILE__, __LINE__, __method__, "setting @dom_root to first_element=#{first_element}" ]}
            self.dom_root = first_element
          else
            # in a separate model?
            fail "#{self.class.name}##{__method__}:#{__LINE_} : dom_root= must be called first"
          end
        end
        @dom_root
      end

      # TODO: should this be here?
      def dom_root=(element)
        # debug 1, ->{[ __FILE__, __LINE__, __method__, "element = #{element}" ]}
        @dom_root = DOM(element)
        # debug 1, ->{[ __FILE__, __LINE__, __method__, "element = #{element}" ]}
      end

    end
  end
end
